import java.awt.*;
import java.util.*;

public class DisplayCanvas extends Canvas
{
    BNgui gui;
    boolean createLink = false;
    Link tmpLink;
    Point popupPosition;
    SymMouse aSymMouse;
    SymMouseMotion aSymMouseMotion;
    NodeView selectedNode;
    PopupMenu nodePopupMenu1,nodePopupMenu2;

//----- Changed by Hara
    final String menuItemString1[] = {"Cut","---","New Tree","Growth Tree","Remove Tree", "Previous Tree", "Next Tree","Activate TreeSelector", "DeActivate TreeSelector", "---","Input Frame","Node Properties...","Conditional Probability Table..."};
//-----

    final String menuItemString2[] = {"New Node","New Link"};
    int nodeID = 0;
    int i;
    
    Image offImage;
    Graphics offGraphics;
    
    public DisplayCanvas()
    {
        super();
        selectedNode = null;
//	gui = (BNgui)getParent();   // It doesn't work.

        // popupMenu
        //{{
            nodePopupMenu1 = createPopupMenu(menuItemString1);
            add(nodePopupMenu1);
            nodePopupMenu2 = createPopupMenu(menuItemString2);
            add(nodePopupMenu2);
        /*
        nodePopupMenu1 = new PopupMenu();
        for(i=0;i<menuItemString1.length;i++){
            nodePopupMenu1.add(menuItemString1[i]);
        }
        add(nodePopupMenu1);
                
        nodePopupMenu2 = new PopupMenu();
        for(i=0;i<2;i++){
            if(menuItemString
            nodePopupMenu2.add(menuItemString2[i]);
        }
        add(nodePopupMenu2);
        
        */
        //}}
        aSymMouse = new SymMouse();
        aSymMouseMotion = new SymMouseMotion();
        addMouseListener(aSymMouse);
        addMouseMotionListener(aSymMouseMotion);
        SymAction lSymAction = new SymAction();
		nodePopupMenu1.addActionListener(lSymAction);
		nodePopupMenu2.addActionListener(lSymAction);
    }
 
    public void setBNgui(BNgui g){
	gui = g;
    }

    PopupMenu createPopupMenu(String menuItem[])
    {
        PopupMenu menu;
        menu = new PopupMenu();
        for(i=0;i<menuItem.length;i++){
            if(menuItem[i] == "---") menu.addSeparator();
            else menu.add(menuItem[i]);
        }
        return menu;
    }
 
    //{{
    public void addNode(String name,int type, String desc,int id,int dimension)
    {
        int pos = findNode(id);
         if (pos < 0){
	// if no node is found, create new node.
	    gui.createNode(name);
         }else {
            Node n = ((NodeView)gui.nodes.elementAt(pos)).getNode();
            n.changeName(name);
	    n.getNodeView().setNameSize(name);
            n.setType(type+1);
            n.setDescription(desc); 
            n.setDimension(dimension);
         }
    }

    public void addNode(Point pos){
	gui.createNode(pos);
    }

    public int findNode(int id)
    {
        for(i=0;i<gui.nodes.size();i++)
        {
            NodeView node = (NodeView)gui.nodes.elementAt(i);
            if (node.getNode().getID() == id) return i;
        }
        return -1;
    }
    public Vector getNodes(){
        return gui.nodes;
    }
    
    
    public void addLink(NodeView sNode,NodeView eNode)
    {
            Link edge = new Link(sNode,eNode);
            gui.getLinks().addElement(edge);
   //         System.out.println(edge);
            Tree t = eNode.getNode().getTree();
            eNode.getTreeView().addLink(edge);
            t.addParent(sNode.getNode());
            
    }
    public void addLink(int s,int e)
    {
        NodeView sNode,eNode;
        sNode = (NodeView)gui.getNodes().elementAt(s);
        eNode = (NodeView)gui.getNodes().elementAt(e);
        addLink(sNode,eNode);
    }
    public void addLink()
    {
        createLink = true;
    }

    public NodeView getSelectedNode()
    {
        return selectedNode;
    }
    //}}
    /*
    public void mousedispatch(java.awt.event.MouseEvent event)
    {
        System.out.println(event.getX()+","+event.getY());
    }
    */

    public void mkOffScrean()
    {
        if (offImage == null){
	      while(getSize().width==0){}
              offImage = createImage(getSize().width,getSize().height);
              if(offImage != null){
	            while(offGraphics == null){
			offGraphics = offImage.getGraphics();
		    }
	      }
        }
    }
    public synchronized void paint(Graphics g)
    {
         mkOffScrean();
         offGraphics.clearRect(0,0,getSize().width,getSize().height);
         drawGraph(offGraphics);
         g.drawImage(offImage, 0, 0, this);
        
    }
    
    public void repaint()
    {
        paint(getGraphics());
    }

    public synchronized void drawGraph(Graphics g)
    {
        int i;
        
//        super.paint(g);
       
        if (tmpLink != null)
            tmpLink.paint(g,Color.black);

//----- Deleted by Hara
/*
	if(gui.getLinks() !=null){
        	for(i=0; i<gui.getLinks().size(); i++){
            	Link link = (Link)gui.links.elementAt(i);
            	link.paint(g);
        	}
	}        
*/
//-----
	if(gui.getNodes() !=null){
        	for(i=0; i<gui.getNodes().size(); i++){
            	NodeView node = (NodeView)gui.getNodes().elementAt(i);
            	node.paint(g);
        	}
	}        
    } 
        
    public void setSize(Dimension size){
        super.setSize(size);
        offImage = null;
    }
    
	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseClicked(java.awt.event.MouseEvent event)
		{
				NodemouseClicked(event);
		}
		public void mousePressed(java.awt.event.MouseEvent event)
		{
		    if(createLink){
		        LinkmousePressed(event);
		    }else{
				NodemousePressed(event);
			}
		}
		public void mouseReleased(java.awt.event.MouseEvent event)
		{
		    if(createLink){
		        LinkmouseReleased(event);
		    }else{
				NodemouseReleased(event);
			}
		}
		
	}
	class SymMouseMotion extends java.awt.event.MouseMotionAdapter
	{
		public void mouseDragged(java.awt.event.MouseEvent event)
		{
		    if(createLink){
		        LinkmouseDragged(event);
		    }else{
				NodemouseDragged(event);
			}
		}
		public void mouseMoved(java.awt.event.MouseEvent event)
		{
		    if(!createLink)
				NodemouseMoved(event);
		}
	}

	void NodemouseClicked(java.awt.event.MouseEvent event)
	{
        Point pos=event.getPoint();
        NodeView prevSelNode = selectedNode;   
        selectedNode = insideNode(pos);
        if(prevSelNode != null && prevSelNode != selectedNode)
            prevSelNode.getNode().setStatus(0);
        if(selectedNode != null) selectedNode.getNode().setStatus(1);
        repaint();
	}
	void NodemousePressed(java.awt.event.MouseEvent event)
	{
        Point pos=event.getPoint();
        NodeView prevSelNode = selectedNode;   
        selectedNode = insideNode(pos);
        if(prevSelNode != null && prevSelNode != selectedNode)
            prevSelNode.getNode().setStatus(0);
        if(selectedNode != null){ 
            selectedNode.getNode().setStatus(1);
        //    System.out.println(event.getComponent());
            if(event.getModifiers() == event.BUTTON3_MASK){
                nodePopupMenu1.show(event.getComponent(),event.getX(),event.getY());
                event.consume();
            }
        }else{
           if(event.getModifiers() == event.BUTTON3_MASK){
                nodePopupMenu2.show(event.getComponent(),event.getX(),event.getY());
                popupPosition = pos;
           }
        }
        repaint();
        // if(selectedNode != null) { System.out.println("Clicked:"+selectedNode);
        //}else{System.out.println("No Node found");}

	}
    void NodemouseReleased(java.awt.event.MouseEvent event)
	{
        if (createLink){
             setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            createLink = false;
        }
	}
	
	void LinkmousePressed(java.awt.event.MouseEvent event)
	{
        Point pos=event.getPoint();
        NodeView prevSelNode = selectedNode;   
        selectedNode = insideNode(pos);
        if(prevSelNode != null && prevSelNode != selectedNode)
            prevSelNode.getNode().setStatus(0);
        if(selectedNode != null){ 
            selectedNode.getNode().setStatus(1);
        }
        repaint();
	}
	void LinkmouseReleased(java.awt.event.MouseEvent event)
	{
	    Point pos=event.getPoint();
	    NodeView endNode = insideNode(pos);
	    if (endNode != null && endNode != selectedNode){
	        addLink(selectedNode,endNode);
	    }
	    tmpLink = null;
        createLink = false;
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        repaint();
	}
	
	void NodemouseDragged(java.awt.event.MouseEvent event)
	{
        Point pos=event.getPoint();
        if (selectedNode != null){
            selectedNode.setLocation(pos);
            repaint();
        }
        
	}
	void LinkmouseDragged(java.awt.event.MouseEvent event)
	{
	    Point pos=event.getPoint();
	    
	    if ( selectedNode != null ){
	        if(tmpLink == null)
	            tmpLink= new Link(selectedNode.getCenter(), pos);
	        tmpLink.setEndPos(pos);
	    }
        repaint();;
	}
    void NodemouseMoved(java.awt.event.MouseEvent event)
    {
        Point pos=event.getPoint();
	}
	
	NodeView insideNode(Point pos)
	{
	    int i;
	    for(i=0;i<gui.getNodes().size();i++){
	        NodeView n=(NodeView)gui.getNodes().elementAt(i);
	        if (n.contains(pos)) return n;
	    }
	    return null;
	}
	Vector insideNodes(Point pos)
	{
	    int i;
	    Vector ns = new Vector(1);
	    for(i=0;i<gui.getNodes().size();i++){
	        NodeView n=(NodeView)gui.getNodes().elementAt(i);
	        if (n.contains(pos)) ns.addElement(n);
	    }
	    return ns;
	}
	
	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			String actionCommand = event.getActionCommand();
			//System.out.println(actionCommand);
			if (actionCommand == menuItemString2[0]){ // Create Node
			  addNode(popupPosition);
			}else if (actionCommand == menuItemString2[1]){ // Create Link
			  createLink = true;
			  setCursor(new Cursor(Cursor.HAND_CURSOR));

//----- Changed and Appended by Hara

			}else if (actionCommand == "Cut"){ // Cut Node
			  gui.removeNode(selectedNode.getNode());
			  selectedNode = null;
			}else if (actionCommand == "Node Properties..."){ // Node Information
			  gui.Show_createNodePanel(selectedNode.getNode());
			}else if (actionCommand == "Conditional Probability Table..."){// Conditional Probability Table
			  if (selectedNode.getNode().getType() == 1){
			        (new TableFrame(selectedNode)).show();
			  }
			}else if (actionCommand == "Input Frame"){
			     (new InputEvidenceFrame(selectedNode.getNode())).show();
			}else if (actionCommand == "New Tree"){
			  gui.addTree();
			}else if (actionCommand == "Growth Tree"){
			  gui.cloneTree();
			}else if (actionCommand == "Remove Tree"){
			  gui.removeTree();
			}else if (actionCommand == "Previous Tree"){
			  gui.prevTree();
			}else if (actionCommand == "Next Tree"){
			  gui.nextTree();
//-----
			}else if (actionCommand == "Activate TreeSelector"){
			  gui.activateTreeSelector();
			}else if (actionCommand == "DeActivate TreeSelector"){
			  gui.deactivateTreeSelector();
			}

			repaint();
		}
	}
}
