import java.awt.*;

public class CellLabel extends Label
{
    boolean selected;
    
    public CellLabel()
    {
        super();
        setAlignment(2);
    }
    public CellLabel(String label)
    {
        super(label);
        setAlignment(2);
    }
    public CellLabel(String label, int align)
    {
        super(label,align);
    }

    public void paint(Graphics g)
    {
        Color c;
        c=g.getColor();
        if (selected) g.setColor(Color.red);
        else g.setColor(Color.gray);
        g.drawRect(0,0,getSize().width-1,getSize().height-1);
        super.paint(g);
        g.setColor(c);
    }
    
    public void setSelected (boolean s)
    {
        selected = s;
    }
    public void repaint()
    {
        paint(getGraphics());
    }
}