/*
	A basic extension of the java.awt.Dialog class
 */

import java.awt.*;

public class CreateNode extends Dialog
{
	public CreateNode(Frame parent, boolean modal)
	{
		super(parent, modal);

		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(getInsets().left + getInsets().right + 295,getInsets().top + getInsets().bottom + 308);
		cancelButton = new java.awt.Button();
		cancelButton.setLabel("Cancel");
		cancelButton.setBounds(getInsets().left + 132,getInsets().top + 253,64,24);
		cancelButton.setBackground(new Color(12632256));
		add(cancelButton);
		okButton = new java.awt.Button();
		okButton.setLabel("OK");
		okButton.setBounds(getInsets().left + 60,getInsets().top + 253,64,24);
		okButton.setBackground(new Color(12632256));
		add(okButton);
		choiceType = new java.awt.Choice();
		choiceType.addItem("Descrete");
		choiceType.addItem("Continuous");
		add(choiceType);
		choiceType.setBounds(getInsets().left + 96,getInsets().top + 34,132,24);
		choiceType.setFont(new Font("Dialog", Font.PLAIN, 10));
		labelType = new java.awt.Label("Type:");
		labelType.setBounds(getInsets().left + 36,getInsets().top + 35,36,18);
		add(labelType);
		labelName = new java.awt.Label("Name:");
		labelName.setBounds(getInsets().left + 36,getInsets().top + 13,48,18);
		add(labelName);
		textFieldName = new java.awt.TextField();
		textFieldName.setBounds(getInsets().left + 96,getInsets().top + 11,132,24);
		textFieldName.setFont(new Font("Dialog", Font.PLAIN, 10));
		textFieldName.setBackground(new Color(16777215));
		add(textFieldName);
		labelDescription = new java.awt.Label("Description:");
		labelDescription.setBounds(getInsets().left + 11,getInsets().top + 111,74,18);
		add(labelDescription);
		textAreaDescription = new java.awt.TextArea();
		textAreaDescription.setBounds(getInsets().left + 15,getInsets().top + 137,270,105);
		textAreaDescription.setFont(new Font("Dialog", Font.PLAIN, 10));
		add(textAreaDescription);
		buttonMore = new java.awt.Button();
		buttonMore.setLabel("More >>");
		buttonMore.setBounds(getInsets().left + 207,getInsets().top + 253,64,24);
		buttonMore.setBackground(new Color(12632256));
		add(buttonMore);
		labelNodeID = new java.awt.Label("-1",Label.CENTER);
		labelNodeID.setBounds(getInsets().left + 99,getInsets().top + 58,43,15);
		add(labelNodeID);
		labelID = new java.awt.Label("ID:");
		labelID.setBounds(getInsets().left + 36,getInsets().top + 57,36,18);
		add(labelID);
		textFieldDimension = new java.awt.TextField();
		textFieldDimension.setBounds(getInsets().left + 96,getInsets().top + 76,132,24);
		textFieldDimension.setFont(new Font("Dialog", Font.PLAIN, 10));
		textFieldDimension.setBackground(new Color(16777215));
		add(textFieldDimension);
		labelDimension = new java.awt.Label("Dimension:");
		labelDimension.setBounds(getInsets().left + 24,getInsets().top + 79,70,18);
		add(labelDimension);
		setTitle("CreateNodeDialog");
		setResizable(false);
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		okButton.addActionListener(lSymAction);
		cancelButton.addActionListener(lSymAction);
		buttonMore.addActionListener(lSymAction);
		//}}
		parentFrame =(BNgui)parent;
	}
	
	public void addNotify()
	{
  	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the getInsets
		setSize(getInsets().left + getInsets().right + d.width, getInsets().top + getInsets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(getInsets().left, getInsets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;


	public CreateNode(Frame parent, String title, boolean model)
	{
		this(parent, model);
		setTitle(title);
	}
	//
	public void setNode(Node n)
	{
	    node = n;
	    setName(node.getName());
	    setType(node.getType()-1);
	    setDescription(node.getDescription());
	    setNodeID(node.getID());
	    setDimension(node.getDimension());
    }
    public Node getNode()
    {
        return node;
    }
    
    public void setName(String name){
        textFieldName.setText(name);
    }
    public void setDimension(int Dim){
        textFieldDimension.setText(Integer.toString(Dim));
    }
    public void setType(int type){
       try {
			choiceType.select(type);
		} catch (IllegalArgumentException e) { }
    }
    public void setDescription(String description){
        textAreaDescription.setText(description);
    }
    public void setNodeID(int id){
        labelNodeID.setText(Integer.toString(id));
    }
    // Get
    public String getName(){
        return textFieldName.getText();
    }
    public int getType(){
	    return choiceType.getSelectedIndex();
    }
    public String getDescription(){
        return textAreaDescription.getText();
    }
    public int getNodeID(){
        return  Integer.parseInt(labelNodeID.getText());
    }
    
	public synchronized void show()
	{
		Rectangle bounds = getParent().getBounds();
		Rectangle abounds = getBounds();

		setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
			 bounds.y + (bounds.height - abounds.height)/2);

		super.show();
	}

	//{{DECLARE_CONTROLS
	java.awt.Button cancelButton;
	java.awt.Button okButton;
	java.awt.Choice choiceType;
	java.awt.Label labelType;
	java.awt.Label labelName;
	java.awt.TextField textFieldName;
	java.awt.Label labelDescription;
	java.awt.TextArea textAreaDescription;
	java.awt.Button buttonMore;
	java.awt.Label labelNodeID;
	java.awt.Label labelID;
	java.awt.TextField textFieldDimension;
	java.awt.Label labelDimension;
	//}}
    BNgui parentFrame;
    Node node;
    
	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == CreateNode.this)
				Dialog1_WindowClosing(event);
		}
	}
	
	void Dialog1_WindowClosing(java.awt.event.WindowEvent event)
	{
		hide();
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == okButton)
				okButton_Action(event);
			else if (object == cancelButton)
				cancelButton_Action(event);
			else if (object == buttonMore)
				buttonMore_Action(event);
		}
	}

	void okButton_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Hide the Dialog
		setVisible(false);
		//}}		 
		 parentFrame.addNode(textFieldName.getText(),choiceType.getSelectedIndex(),textAreaDescription.getText(),Integer.parseInt(labelNodeID.getText()),Integer.parseInt(textFieldDimension.getText()));
	}

	void cancelButton_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Hide the Dialog
		setVisible(false);
		//}}
	}

	void buttonMore_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Create and show as modal
	//	parentFrame.Show_createNeuralNetDialog(node);
		//}}
	}
	
}
