/*
  ErrorGraphClasss
*/


import java.awt.*;
import java.util.*;

public class GraphCanvas extends Canvas
{
    private int x_axis, y_axis;
    private Image offImage;
    private Graphics offGraphics;
    private Vector data,dataX,dataY;
    private float maxValue;
    private int dataSize;
    private boolean drawTrace = true;

    /*
      Constractor
    */
    public GraphCanvas()
    {
  //      super();
        data = new Vector(1);
        dataX = new Vector(1);
        dataY = new Vector(1);
        dataSize = 0;
        maxValue = (float)1.25;
        show();
    }

    /*
       Drawinng  Methods
    */

    public void mkOffScreen()
    {
        if (offImage == null){
              offImage = createImage(getSize().width,getSize().height);
              if(offImage != null)
                 offGraphics = offImage.getGraphics();
        }
    }
    /* update */

    public void update()
    {
        paint(this.getGraphics());
    }


    public void update(Graphics g)
    {
        paint(g);
    }

    /* paint */
    public void paint(Graphics g)
    {
        mkOffScreen();
        //clearCanvas(g);
        if (offImage != null){
            clearCanvas(offGraphics);
            drawGraph(offGraphics);
            g.drawImage(offImage, 0, 0, this);
        }else{
            clearCanvas(g);
            drawGraph(g);
        }
    }

    /* drawErrorGraph */
    public void drawGraph (Graphics g)
    {
        int i,ox=0,oy=0,nx,ny;
        double sx = 0;
        float sy = getSize().height / maxValue;
        Double dataValue;

        int maxX, maxY;
        int tag=10;

        maxX=getSize().width - 10;
        maxY=getSize().height - 15;

        g.setFont( new Font("Dialog", Font.PLAIN, 12) );

        if (dataSize > 0){
            sx = getSize().width / (double)dataSize;
            tag = (int)Math.round( 50.0 / sx )/10 * 10;
            if (tag < 10) tag =10;
            ox = 10;
            dataValue = (Double)data.elementAt(0);
            oy = maxY - Math.round( sy * dataValue.floatValue());
        }
        /* draw Axis */

        drawAxis(g,getSize().width, getSize().height);

        /* draw Data */
       // System.out.println( data.toString() );

        for (i=1; i < dataSize - 1; i++ ){
            nx = (int)Math.floor(sx *i) + 10;
            dataValue = (Double)data.elementAt(i);
            ny = maxY - Math.round(sy * dataValue.floatValue());
            Color c = g.getColor();
            g.setColor(Color.red);
            g.drawLine( ox, oy, nx, ny);
            g.setColor(c);
            ox = nx; oy = ny;
       //     tag = nx - prevtag;
            if ((i % tag ) == 0 ) {

                g.drawLine(nx,getSize().height-20,nx,getSize().height-10);
                g.drawString(Integer.toString(i),nx-6, getSize().height);
            }
        }
    }
    
    public void drawXYGraph (Graphics g)
    {
        int i,ox=0,oy=0,nx,ny;
        double sx = 0;
        float sy = getSize().height / maxValue;
        Double dataValue;

        int maxX, maxY;
        int tag=10;

        maxX=getSize().width - 10;
        maxY=getSize().height - 15;

        g.setFont( new Font("Dialog", Font.PLAIN, 12) );
        
        int maxXdata = ((Double)dataX.elementAt(dataSize)).intValue();
        
        
        if (maxXdata > 0){
            sx = getSize().width / (double)maxXdata;
            tag = (int)Math.round( 50.0 / sx )/10 * 10;
            if (tag < 10) tag =10;
            ox = 10;
            dataValue = (Double)dataY.elementAt(0);
            oy = maxY - Math.round( sy * dataValue.floatValue());
        }
        /* draw Axis */

        drawAxis(g,getSize().width, getSize().height);

        /* draw Data */

        for (i=1; i < dataSize - 1; i++ ){
            int x = ((Double)dataX.elementAt(i)).intValue();
            nx = (int)Math.floor(sx * x) + 10;
            dataValue = (Double)data.elementAt(i);
            ny = maxY - Math.round(sy * dataValue.floatValue());
            Color c = g.getColor();
            g.setColor(Color.red);
            g.drawLine( ox, oy, nx, ny);
            g.setColor(c);
            ox = nx; oy = ny;
            if ((x % tag ) == 0 ) {
                g.drawLine(nx,getSize().height-20,nx,getSize().height-10);
                g.drawString(Integer.toString(i),nx-6, getSize().height);
            }
        }
    }
    
    
    
    public void drawAxis(Graphics g,int Width, int Height)
    {
        g.drawLine(10, 0, 10, Height-5);
        g.drawLine(0, Height-15, Width, Height-15);
    }

    public void clearCanvas(Graphics g)
    {
        g.clearRect(0,0,getSize().width,getSize().height);
    }
    /* Add Elements to data */
    public void addData(double v)
    {
        data.addElement((new Double(v)));
        dataSize++ ;
        update();
    }
    public void addData(double x,double y)
    {
        dataX.addElement(new Double(x));
        dataY.addElement(new Double(y));
        dataSize++ ;
        update();
    }
    
    
    public void resetAll(){
        
        data = new Vector(1);
        dataSize = 0;
        update(getGraphics());
    }

}