/*
	A basic extension of the java.awt.Frame class
 */

import java.awt.*;
import java.util.*;

public class InputEvidenceFrame extends Frame
{
	public InputEvidenceFrame()
	{
		//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(getInsets().left + getInsets().right + 500,getInsets().top + getInsets().bottom + 300);
		pallet1 = new Pallet();
		pallet1.setLayout(null);
		pallet1.setBounds(getInsets().left + 0,getInsets().top + 0,500,20);
		pallet1.setBackground(new Color(12632256));
		add(pallet1);
	
		OKButton = new java.awt.Button();
		OKButton.setLabel("OK");
		OKButton.setBounds(37,1,72,18);
		OKButton.setBackground(new Color(12632256));
		pallet1.add(OKButton);
		scrollPane1 = new java.awt.ScrollPane(ScrollPane.SCROLLBARS_AS_NEEDED);
		scrollPane1.setBounds(getInsets().left,getInsets().top + 20,497,277);
		add(scrollPane1);
		setTitle("Untitled");
		//}}
		tablePanel1 = new TablePanel();
		scrollPane1.add(tablePanel1);

		//{{INIT_MENUS
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		SymComponent aSymComponent = new SymComponent();
		this.addComponentListener(aSymComponent);
		OKButton.addActionListener(lSymAction);
		//}}
	}

	public InputEvidenceFrame(String title)
	{
		this();
		setTitle(title);
	}

        public InputEvidenceFrame(Node n)
	{
		this();

		node=n;
		Vector parentNodes = n.getParents();
		tablePanel1.setColumnLabels(n.getStatesName());

                int ddim = n.getDimension()- n.getStatesName().size();
                if (ddim < 0){
                  for(int i = ddim ; i < 0; i++)
                        tablePanel1.deleteColumn();
                }else{
                  for(int i = 0 ; i < ddim; i++)
                        tablePanel1.addColumn();
                }



		int type = n.getType();
		if(type == 2){
			String[] labels={"Ave", "Dev"};
			tablePanel1.addRowLabel("",labels,1);
		}else{
			String[] labels={"Value"};
			tablePanel1.addRowLabel("",labels,1);
		}
	}

	public synchronized void show()
	{
		setLocation(50, 50);
		super.show();
	}

	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();
	    
		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the getInsets
		setSize(getInsets().left + getInsets().right + d.width, getInsets().top + getInsets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(getInsets().left, getInsets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	Pallet pallet1;
	java.awt.TextField textField1;
	java.awt.Label label1;
	java.awt.Button OKButton;
	java.awt.ScrollPane scrollPane1;
	//}}
	TablePanel tablePanel1;
	Node node;

	//{{DECLARE_MENUS
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == InputEvidenceFrame.this)
				Frame1_WindowClosing(event);
		}
	}
	
	void Frame1_WindowClosing(java.awt.event.WindowEvent event)
	{
		hide();		 // hide the Frame
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == OKButton)
				OKButton_Action(event);
				
				scrollPane1.doLayout();
		}
	}

	class SymComponent extends java.awt.event.ComponentAdapter
	{
		public void componentResized(java.awt.event.ComponentEvent event)
		{
			Object object = event.getSource();
			if (object == InputEvidenceFrame.this)
				TableFrame_ComponentResized(event);
		}
	}

	void TableFrame_ComponentResized(java.awt.event.ComponentEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// setWidth...
		{
			pallet1.setWidth(getSize().width);
		}
		//}}
			 
		{
			scrollPane1.setSize(getSize().width-8, getSize().height-46);
			tablePanel1.resize();
		}
		scrollPane1.doLayout();
	}

	void OKButton_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Hide the Frame
		setVisible(false);
		node.setStatesName(tablePanel1.getColumnLabels());
		//}}
	}
}
