import java.awt.*;

public class Link extends Rectangle
{
    Point startPos,endPos;
    NodeView sNode,eNode;
    final double tan15 = Math.tan(0.2618);
    int alen = 10;
    int centerX,centerY;
    int aX,aY,aX2,aY2;

    public Link()
    {
        super();
        startPos = new Point();
        endPos = new Point();
    }
    public Link(Point s, Point e)
    {
        this();
        startPos.setLocation(s);
        endPos.setLocation(e);
        setBounds(s.x,s.y,s.x-e.x,s.y-e.y);
    }

    public Link(NodeView s,NodeView e)
    {
        this( s.getCenter() ,e.getCenter());
        sNode=s;
        eNode=e;
    }
    public boolean containNode(NodeView node)
    {
        if (node== sNode || node == eNode) return true;
        else return false;
    }
    public synchronized void paint(Graphics g,Color c)
    {
        g.setColor(c);
        if(sNode != null) setStartPos(sNode.getCenter());
        if(eNode != null) setEndPos( eNode.getCenter());
        g.drawLine(centerX,centerY,centerX+aX,centerY+aY);
        g.drawLine(centerX,centerY,centerX+aX2,centerY+aY2);
        g.drawLine(startPos.x,startPos.y, endPos.x, endPos.y);

    }
     public synchronized void paint(Graphics g)
    {
        paint(g,Color.blue);
    }
    public void setEndPos(Point pos)
    {
        endPos = pos;
        CalcArrows();
    }
    public void setStartPos(Point pos)
    {
        startPos = pos;
        CalcArrows();
    }
    void CalcArrows()
    {
        double X,sinth,costh,lenV,vX,vY;

        X = tan15*alen;
        centerX = (startPos.x + endPos.x)/2;
        centerY = (startPos.y + endPos.y)/2;
        vX = endPos.x - startPos.x;
        vY = endPos.y - startPos.y;
        lenV = Math.sqrt(vX*vX+vY*vY);
        costh = vX/lenV;
        sinth = vY/lenV;


        aX = (int)Math.round(-alen*costh -X*sinth);
        aY = (int)Math.round(-alen*sinth +X*costh);
        aX2 = (int)Math.round(-alen*costh +X*sinth);
        aY2 = (int)Math.round(-alen*sinth -X*costh);
    }
    public NodeView getParentNode()
    {
        return sNode;
    }
    public NodeView getChildNode()
    {
        return eNode;
    }

}