import java.awt.*;

public class NeuralNetDialog extends Dialog
{
	public NeuralNetDialog(Frame parent, boolean modal)
	{
		super(parent, modal);
		//{{INIT_CONTROLS
		setLayout(null);
		setSize(getInsets().left + getInsets().right + 460,getInsets().top + getInsets().bottom + 422);
		buttonCreate = new java.awt.Button();
		buttonCreate.setLabel("Create");
		buttonCreate.setBounds(getInsets().left + 197,getInsets().top + 386,108,24);
		buttonCreate.setBackground(new Color(12632256));
		add(buttonCreate);
		buttonCancel = new java.awt.Button();
		buttonCancel.setLabel("Cancel");
		buttonCancel.setBounds(getInsets().left + 311,getInsets().top + 385,108,24);
		buttonCancel.setBackground(new Color(12632256));
		add(buttonCancel);
		label_LearningProperties = new java.awt.Label("Learning Parameters",Label.CENTER);
		label_LearningProperties.setBounds(getInsets().left + 57,getInsets().top + 165,126,18);
		label_LearningProperties.setForeground(new Color(0));
		add(label_LearningProperties);
		label_Condition = new java.awt.Label("Condition for Leaning Termination",Label.CENTER);
		label_Condition.setBounds(getInsets().left + 45,getInsets().top + 273,216,18);
		label_Condition.setForeground(new Color(0));
		add(label_Condition);
		checkbox_Iteration = new java.awt.Checkbox("Iteration");
		checkbox_Iteration.setBounds(getInsets().left + 69,getInsets().top + 297,108,18);
		checkbox_Iteration.setForeground(new Color(0));
		add(checkbox_Iteration);
		checkbox_threshold = new java.awt.Checkbox("Error threshold");
		checkbox_threshold.setBounds(getInsets().left + 68,getInsets().top + 321,108,18);
		add(checkbox_threshold);
		textField_Iteration = new java.awt.TextField();
		textField_Iteration.setText("1000");
		textField_Iteration.setBounds(getInsets().left + 177,getInsets().top + 297,159,24);
		textField_Iteration.setFont(new Font("Dialog", Font.PLAIN, 10));
		add(textField_Iteration);
		textField_Threshold = new java.awt.TextField();
		textField_Threshold.setText("0.01");
		textField_Threshold.setBounds(getInsets().left + 177,getInsets().top + 321,159,24);
		textField_Threshold.setFont(new Font("Dialog", Font.PLAIN, 10));
		add(textField_Threshold);
		label_Efficiency = new java.awt.Label("Efficiency");
		label_Efficiency.setBounds(getInsets().left + 93,getInsets().top + 201,57,18);
		add(label_Efficiency);
		label_Momentum = new java.awt.Label("Momentum");
		label_Momentum.setBounds(getInsets().left + 81,getInsets().top + 225,72,18);
		add(label_Momentum);
		textField_Efficiency = new java.awt.TextField();
		textField_Efficiency.setText("0.1");
		textField_Efficiency.setBounds(getInsets().left + 177,getInsets().top + 201,144,24);
		textField_Efficiency.setFont(new Font("Dialog", Font.PLAIN, 10));
		add(textField_Efficiency);
		textField_Momentum = new java.awt.TextField();
		textField_Momentum.setText("0.1");
		textField_Momentum.setBounds(getInsets().left + 177,getInsets().top + 225,144,24);
		textField_Momentum.setFont(new Font("Dialog", Font.PLAIN, 10));
		add(textField_Momentum);
		label_InputNodes = new java.awt.Label("Input Nodes");
		label_InputNodes.setBounds(getInsets().left + 53,getInsets().top + 49,84,18);
		add(label_InputNodes);
		label_OutputNodes = new java.awt.Label("Output Nodes");
		label_OutputNodes.setBounds(getInsets().left + 53,getInsets().top + 97,84,18);
		add(label_OutputNodes);
		label_HiddenNodes = new java.awt.Label("Hidden Nodes");
		label_HiddenNodes.setBounds(getInsets().left + 53,getInsets().top + 73,84,18);
		add(label_HiddenNodes);
		label_InputNodesValue = new java.awt.Label("2");
		label_InputNodesValue.setBounds(getInsets().left + 168,getInsets().top + 50,48,18);
		add(label_InputNodesValue);
		label_OutputNodeValue = new java.awt.Label("1");
		label_OutputNodeValue.setBounds(getInsets().left + 168,getInsets().top + 98,50,18);
		add(label_OutputNodeValue);
		textField_Hidden = new java.awt.TextField();
		textField_Hidden.setText("10");
		textField_Hidden.setBounds(getInsets().left + 166,getInsets().top + 73,144,24);
		textField_Hidden.setFont(new Font("Dialog", Font.PLAIN, 10));
		add(textField_Hidden);
		label1 = new java.awt.Label("LinkSet ");
		label1.setBounds(getInsets().left + 22,getInsets().top + 12,84,18);
		add(label1);
		setTitle("Create NeuralNetwork....");
		//}}
		


		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		buttonCreate.addActionListener(lSymAction);
		buttonCancel.addActionListener(lSymAction);
		//}}
	}
	
	public void addNotify()
	{
  	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the getInsets
		setSize(getInsets().left + getInsets().right + d.width, getInsets().top + getInsets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(getInsets().left, getInsets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;


	public NeuralNetDialog(Frame parent, String title, boolean modal)
	{
		this(parent, modal);
		setTitle(title);
	}

	public synchronized void show()
	{
		Rectangle bounds = getParent().getBounds();
		Rectangle abounds = getBounds();

		move(bounds.x + (bounds.width - abounds.width)/ 2,
			 bounds.y + (bounds.height - abounds.height)/2);

		super.show();
	}

	//{{DECLARE_CONTROLS
	java.awt.Button buttonCreate;
	java.awt.Button buttonCancel;
	java.awt.Label label_LearningProperties;
	java.awt.Label label_Condition;
	java.awt.Checkbox checkbox_Iteration;
	java.awt.Checkbox checkbox_threshold;
	java.awt.TextField textField_Iteration;
	java.awt.TextField textField_Threshold;
	java.awt.Label label_Efficiency;
	java.awt.Label label_Momentum;
	java.awt.TextField textField_Efficiency;
	java.awt.TextField textField_Momentum;
	java.awt.Label label_InputNodes;
	java.awt.Label label_OutputNodes;
	java.awt.Label label_HiddenNodes;
	java.awt.Label label_InputNodesValue;
	java.awt.Label label_OutputNodeValue;
	java.awt.TextField textField_Hidden;
	java.awt.Label label1;
	//}}
	
	CreateNode parentFrame;
	Node node;

    public void setNode(Node n)
    {
        node = n;
        label_InputNodesValue.setText(Integer.toString(node.getTree().getInputNodeSize()));
        label_OutputNodeValue.setText(Integer.toString(node.getTree().getOutputNodeSize()));
    }
    
	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == NeuralNetDialog.this)
				Dialog1_WindowClosing(event);
		}
	}
	
	void Dialog1_WindowClosing(java.awt.event.WindowEvent event)
	{
		hide();
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == buttonCreate)
				buttonCreate_Action(event);
			else if (object == buttonCancel)
				buttonCancel_Action(event);
		}
	}

	void buttonCreate_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		node.getTree().createNeuralNetwork(getHiddenNumber(),getEfficiency(),getMomentum(),getIteration(),getThreshold());
			 
		hide();

	}

	void buttonCancel_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Invalidate the Dialog
		hide();
		//}}
	}
	int getHiddenNumber()
	{
	    return (Integer.parseInt(textField_Hidden.getText()));
	}
	double getEfficiency()
	{
	    return ((Double.valueOf(textField_Efficiency.getText())).doubleValue());
	}
	double getMomentum()
	{
	    return ((Double.valueOf(textField_Momentum.getText())).doubleValue());
	}
	int getIteration()
	{
	     return (Integer.parseInt(textField_Iteration.getText()));
	}
	double getThreshold()
	{
	    return ((Double.valueOf(textField_Threshold.getText())).doubleValue());
	}
}
