import java.awt.*;
import java.util.*;

public class NodeView extends Rectangle
{
    // Variables

 public static int IDcount;
 
 Node node;
 TreeView currentTreeView;
 Vector treeViewSet;

//----- Appended by Hara
 int currentTree;
//-----

 int ID;
 String discription;

 final Color fgColors[] = {Color.white,Color.yellow,Color.green};

// Constracters
//----- Changed by Hara
 public NodeView(Node n){
     super();
     setBounds(0, 0, 24, 18);
     initNodeView(n);
 }

  public NodeView(Point pos, Node n){
     super();
     setBounds(pos.x, pos.y, 24, 18);
     initNodeView(n);
 }

 void initNodeView(Node n)
 {
     node = n; n.setNodeView(this);
     currentTreeView = new TreeView();
     currentTreeView.setTree(n.getTree());
     treeViewSet = new Vector(1);
     treeViewSet.addElement(currentTreeView);
     currentTree = 0;
 }
//-----
public Node getNode()
{
    return node;
}

public void setNode(Node n)
{
    node = n; setNameSize(n.name);
}
// Name
 public String getName(){
    return node.getName();
 }

 public TreeView getTreeView(){
	return currentTreeView;
 }

 public void setTreeView(TreeView tv){
	currentTreeView = tv;
 }

 public void activateTreeSelector(){
	node.activateTreeSelector();
 }

 public void deactivateTreeSelector(){
	node.deactivateTreeSelector();
 }

//----- Append by Hara
 public Vector getTreeViewSet(){
	return treeViewSet;
 }

 public void addTree()
 {
     node.addTree();
     currentTreeView = new TreeView();
     currentTreeView.setTree(node.getTree());
     treeViewSet.addElement(currentTreeView);
     currentTree = treeViewSet.size() - 1;
 }

 public void cloneTree()
 {
     TreeView prevTreeView=currentTreeView;
     node.cloneTree();
     currentTreeView = new TreeView();
     currentTreeView.setTree(node.getTree());
     treeViewSet.addElement(currentTreeView);
     currentTree = treeViewSet.size() - 1;
     currentTreeView.setLinks((Vector)prevTreeView.getLinks().clone());;
 }

 public void removeTree()
 {
     node.removeTree();
     if (treeViewSet.size() == 1){
       treeViewSet.removeElementAt(currentTree);
       addTree();
     }else{
       treeViewSet.removeElementAt(currentTree);
       if(currentTree < treeViewSet.size()){
        currentTreeView=(TreeView)treeViewSet.elementAt(currentTree);
       }else{
	currentTree--;
        currentTreeView=(TreeView)treeViewSet.elementAt(currentTree);
       }
    }
 }

 public void treeAt(int n)
 {
   if (n < treeViewSet.size()) {
	 node.treeAt(n);
	 currentTreeView = (TreeView)treeViewSet.elementAt(n);
	 currentTree = n;
   }
 }

 public void nextTree()
 {
      int next = (currentTree+1) % treeViewSet.size();

      node.treeAt(next);
      treeAt(next);
 }

 public void prevTree()
 {
      int prev = (currentTree-1 + treeViewSet.size()) % treeViewSet.size();

      node.treeAt(prev);
      treeAt(prev);
 }

//-----

 public void setNameSize(String name){
//    getNode().changeName(name);
    setSize(name.length() * 6+ 24,24);
 }

// Description

 public void setDescription(String d){ getNode().setDescription(d); }
 public String getDescription(String d){ return getNode().getDescription() ; }

 // Center Postion
 public Point getCenter(){
    Point center = new Point(x+width/2, y+height/2);
    return center;
 }
 
 // Draw ...

//----- Appended by Hara
 public synchronized void paintCurrentTree (Graphics g){
    currentTreeView.paint(g);
 }
//-----

 public synchronized void paint (Graphics g){

//----- Changed by Hara
    paintCurrentTree(g);
//-----

    Rectangle rect = getBounds();
// Type = 0,1,2 corresponds to (white, yellow, green)
    g.setColor(fgColors[node.getType()]);
    g.fillOval(rect.x,rect.y,rect.width,rect.height);
    g.setColor(Color.black);
    if (node.getStatus() == 1){
        g.drawOval(rect.x-1,rect.y-1, rect.width+2,rect.height+2);
    }
    g.drawOval(rect.x,rect.y, rect.width,rect.height);
    g.drawString(node.getName(),rect.x+12,rect.y+rect.height-6);
 }
}
