/*
  PalletLabe Class for TabPanel
*/


import java.awt.*;
import java.util.*;

public class PalletLabel extends Label
{
    private boolean Active;

    /*
      Constructor
    */
    public PalletLabel()
    {
        super();
        Active = true;
        setBackground(Color.gray);
    }
    public PalletLabel(String S){
        super(S);
        Active = true;
        setBackground(Color.gray);
    }
    public PalletLabel(String S, int pos){
        this(S,pos, false);
    }
    public PalletLabel(String S, int pos, boolean act){
        super(S,pos);
        Active = act;
        if (act){
            setBackground(Color.lightGray);
        }else{
            setBackground(Color.gray);
        }
    }
    /*
        set/get Active
    */
    public void setActive(boolean act)
    {
           Graphics g = getGraphics();

           Active = act;
           if (act){ setBackground(Color.lightGray); }
           else { setBackground(Color.gray); }
           if (g == null){ repaint(); }
           else{ paintAll(g); }
    }
    public boolean getActive()
    {
        return Active;
    }
    /*
        paint() (called from update)
    */
    public void paint(Graphics g){
         int pad,pad2;
         Dimension size = getSize();

        super.paint(g);

        if (Active){
            g.setColor(Color.lightGray);
            pad=pad2=0;
        }else{
            g.setColor(Color.gray);
            pad=1; pad2=3;
        }
        g.draw3DRect(0,0,size.width-1,size.height-pad,true);
        g.draw3DRect(1,1,size.width-3,size.height-pad2,true);
    }
}