/*
   Table Panel Class
*/

import java.awt.*;
import java.util.*;

public class TablePanel extends Panel
{
    int column,row, labelrow, labelcolumn;
    int cellSize,fontSize;
    Vector Table;
    Vector ColumnLabels;
    Vector RowLabels; 
    Vector RowLabelNames,ColumnLabelNames;
    TextField editField;
    CellLabel selectedCell;
    Panel mainTable;
    Vector rowVec;
    /*
        Event
    */
    SymMouse aSymMouse;
    SymAction lSymAction;

    /* 
      Constractors
    */
    public TablePanel()
    {
        super();
        setLayout(null);
        column=1;

        labelrow=0;
        labelcolumn=1;
        cellSize = 4;
        fontSize = 30;

        Table = new Vector(1);
        ColumnLabels = new Vector(1);
        RowLabels = new Vector(1);
        RowLabelNames = new Vector(1);
        ColumnLabelNames = new Vector(1);
        ColumnLabelNames.addElement("");
        rowVec = new Vector(1);
        
        for (int i=0;i<labelrow;i++){
            RowLabels.addElement(new Vector(1));
            RowLabelNames.addElement(new Vector(1));
            rowVec.addElement(new Integer(1));
        }
        row = calcSeries(rowVec,labelrow);
        //setBackground(Color.gray);
        editField = new java.awt.TextField();
        editField.setBounds(0,0,fontSize*cellSize,fontSize);
        editField.setVisible(false);
        selectedCell = null;
        add(editField);

        aSymMouse = new SymMouse();
        lSymAction = new SymAction();
        editField.addActionListener(lSymAction);
        
        initTable();
    }

    public TablePanel(int col,int r)
    {
         this();
         initTable(col,r);
    }
    
    /* Methods */
    public void initTable (int col,int r)
    {
        column=col;
        row=r;
        initTable();
    }

    public void initTable ()
    {
        int i=0,j=0;
        int prevColumn=0,prevRow=0;
        CellLabel textLabel;
        Vector tableColumn;
        
        initColumnLabels(labelcolumn);
 
        for(i=0;i<row;i++){
            for (j=0;j<labelrow;j++){
            initRowLabels((Vector)RowLabels.elementAt(j),((Integer)rowVec.elementAt(j)).intValue(),calcSeries(rowVec,j),labelrow - j,i);
           }
        }
        
        
        prevRow = Table.size();
        for (i=0;i<row || i<prevRow;i++){
            
            if (prevRow <= i){
                tableColumn = new Vector(1);
                Table.addElement(tableColumn);
            }else tableColumn = (Vector)Table.elementAt(i);
            
            prevColumn = tableColumn.size();
            for(j=0;j<column || j < prevColumn;j++){
                
               if (j < column){
                if (prevColumn <= j){
                   textLabel = new CellLabel();
                   textLabel.addMouseListener(aSymMouse);              
                  // textLabel.setText("("+Integer.toString(i)+","+Integer.toString(j)+")");
                   tableColumn.addElement(textLabel);
                   add(textLabel);
                }
              }
              if (i < row && j < column){
                  ((Label)tableColumn.elementAt(j)).setBounds((i+labelcolumn)*cellSize*fontSize,(j+labelrow)*fontSize,fontSize*cellSize+1,fontSize+1);
                  ((Label)tableColumn.elementAt(j)).setVisible(true);
              }else{
                  ((Label)tableColumn.elementAt(j)).setVisible(false);
              }
            }
        }
        resize();
    }
    public void resize()
    {    
     //   setSize(1,labelrow*fontSize,(row+1)*cellSize*fontSize,column*fontSize);
        setSize((row+1)*cellSize*fontSize,(column+labelrow)*fontSize);
    }
    
    int calcSeries(Vector vec, int pos)
    {
        int ans,i;
        ans = 1;
        for (i=0;i<pos;i++)  ans = ans * ((Integer)vec.elementAt(i)).intValue();
        return ans;
    }
    
    /* Column Labels */
    public void initColumnLabels(int level)
    {
        int j;
        CellLabel textLabel;
        int prevColumn = ColumnLabels.size();
        
        if (level > 0){
          for(j=0;j<column || j < prevColumn;j++){
                
              if (prevColumn <= j){
                textLabel = new CellLabel();
                textLabel.addMouseListener(aSymMouse);
                textLabel.setText("State " + j);
            //    textLabel.setBounds(0,(j+labelrow)*fontSize,fontSize*cellSize+1,fontSize+1);
                textLabel.setBackground(Color.lightGray);
                add(textLabel);
                ColumnLabels.addElement(textLabel);
              }else{
                textLabel = (CellLabel)ColumnLabels.elementAt(j);
              }
              if (j < column){
                  textLabel.setBounds(0,(j+labelrow)*fontSize,fontSize*cellSize+1,fontSize+1);
                  textLabel.setText((String)ColumnLabelNames.elementAt(j));
                  textLabel.setVisible(true);
              }else{
                  textLabel.setVisible(false);
              }
          }
        }
    }

   /* Row Labels  */
    public void initRowLabels(Vector Labels,int nrow,int cells,int level, int times)
    {
        int i;
        int rows=cells;
        int cellwidth = fontSize*cellSize;
        
        CellLabel textLabel;
        int prevRow = Labels.size();
        if (level>0 && times < row/nrow/cells){
            Vector rowLabelNames = (Vector)RowLabelNames.elementAt(labelrow-level);
            if (times ==0){
                CellLabel rowLabelName = new CellLabel();
                rowLabelName.setBounds(0,(labelrow-level)*fontSize,fontSize*cellSize+1,fontSize+1);
                rowLabelName.setText((String)rowLabelNames.elementAt(0));
                add(rowLabelName);
            }
          for(i=times*nrow+labelcolumn;i<(times+1)*nrow+labelcolumn +1 || i < prevRow;i++){ 
              if (prevRow <= i-labelcolumn){
                textLabel = new CellLabel();
                textLabel.setBackground(Color.lightGray);
                add(textLabel);
                Labels.addElement(textLabel);
              }else{
                textLabel = (CellLabel)Labels.elementAt(i-labelcolumn);
              }
              if (i < (times+1)*nrow+labelcolumn){
                  textLabel.setBounds((rows*(i-1)+1)*cellwidth,(level-1)*fontSize,rows*cellwidth+1,fontSize+1);
        //          if(textLabel.getText() == "")
        //             textLabel.setText("R"+level+"L"+Integer.toString(i-(times*nrow)));
                  textLabel.setText((String)rowLabelNames.elementAt(i-times*nrow));
                  textLabel.setVisible(true);
              }else{
                  textLabel.setVisible(false);
              }
          }
        }
    }
   
    /*
        Variables
    */
    public void setColumn(int col)
    {
        column = col;
        initTable();
    }
    public void setColumnLabels(Vector labels)  
    {
        ColumnLabelNames = labels;
        column = labels.size();
        initTable();
    }
    public Vector getColumnLabels()
    {
        Vector ans = new Vector(1);
        for (int i=0;i<column; i++){
               ans.addElement(((Label)ColumnLabels.elementAt(i)).getText());
        }
        return ans;
 //       return ColumnLabelNames;
    }
    public void setRow (int r,int pos)
    {
        rowVec.setElementAt(new Integer(r), pos);
        row = calcSeries(rowVec,labelrow);
        initTable();
    }
    public void setRow(int r)
    {
        row = r;
        initTable();
    }
    public void addRow()
    {
        setRow(row+1);
    }
    public void deleteRow()
    {
        if(row > 1) setRow(row-1);
    }
    public void addRowLabel(int n)
    {
        rowVec.addElement(new Integer(n));
        RowLabels.addElement(new Vector(1));
        labelrow++;
        row = calcSeries(rowVec,labelrow);
        initTable();
    }
    public void addRowLabel(String Name, Vector labels,int level)
    {
        Vector label = new Vector(1);
        
        label.addElement(Name);
        System.out.println("add:"+level+" "+labels+" "+RowLabelNames.size());
        for(int i=0;i<labels.size();i++) label.addElement(labels.elementAt(i));
      
        if (RowLabelNames.size() <= level){        
            RowLabels.addElement(new Vector());
            RowLabelNames.addElement(label);
            labelrow++;
            rowVec.addElement(new Integer(labels.size()));
        
        }else{     
            RowLabelNames.setElementAt(label,level);
            rowVec.setElementAt(new Integer(labels.size()), level);
        }
        row = calcSeries(rowVec,labelrow);  
        initTable();
    }
    public void addRowLabel(Vector labels,int level)
    {
        addRowLabel("",labels,level);
    }

    public void addRowLabel(String Name, String[] labels,int level)
    {
        Vector label = new Vector(1);
        
        label.addElement(Name);
        for(int i=0;i<labels.length;i++) label.addElement(labels[i]);
      
        if (RowLabelNames.size() <= level){        
            RowLabels.addElement(new Vector());
            RowLabelNames.addElement(label);
            labelrow++;
            rowVec.addElement(new Integer(labels.length));
        
        }else{     
            RowLabelNames.setElementAt(label,level);
            rowVec.setElementAt(new Integer(labels.length), level);
        }
        row = calcSeries(rowVec,labelrow);  
        initTable();
    }

    public void setRowLabels(Vector labels, int pos)
    {
        Vector Labels = (Vector)RowLabels.elementAt(pos);
        for (int i=0;i<Labels.size();i++)
           ((CellLabel)Labels.elementAt(i)).setText((String)labels.elementAt(i));
        initTable();
    }
    public void deleteRowLabel()
    {
        int n = rowVec.size();
        if(n > 1){
          rowVec.removeElementAt(n);
          RowLabels.removeElementAt(n);
          labelrow--;
          row = calcSeries(rowVec,labelrow);
          initTable();
        }

    }
    public void deleteRowLabel(int level)
    {
        int n = rowVec.size();
        if(n > level){
          rowVec.removeElementAt(level);
          RowLabels.removeElementAt(level);
//          RowLabelNames.removeElement(level);
          labelrow--;
          row = calcSeries(rowVec,labelrow);
          initTable();
        }
    }
    public void addColumn()
    {
        ColumnLabelNames.addElement("State "+column);
        setColumn(column+1);

    }
    public void deleteColumn()
    {
        if (column > 1) setColumn(column-1);
    }
    
    public Object getDate(int r, int c)
    {
           return ((Vector)Table.elementAt(r)).elementAt(c);
    }
    public void setDate(Object data,int r, int c)
    {
         Vector columnTable = (Vector)Table.elementAt(r);
         columnTable.setElementAt(data,c);
    }
    
    // MouseEventHandler
    class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseClicked(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			try {
				editCell((CellLabel)object,true);
			}
			catch(Exception e) { }
		    updateAll();
		}
	}
	/* Redraw */
	void updateAll()
    {
        for(int i=1;i<row+1;i++){
            Vector ColVec = (Vector)Table.elementAt(i-1);
            for(int j=0;j<column;j++){
                CellLabel cell = (CellLabel)ColVec.elementAt(j);
                cell.repaint();
            }
        }
        editField.update(editField.getGraphics());
    }
    /* Edit */
	void editCell(CellLabel cell, boolean mode)
	{
	        if (mode){
			    if(selectedCell != null){
			        selectedCell.setSelected(false);
			        selectedCell.setVisible(true);
			    }
			    selectedCell = cell;
			    selectedCell.setSelected(true);
			    selectedCell.setVisible(false);
			    editField.setText(selectedCell.getText());
			    editField.setLocation(selectedCell.getLocation());
			    editField.setVisible(true);
			}else{
			    cell.setSelected(false);
			    cell.setVisible(true);
			    selectedCell = null;
			    editField.setVisible(false);
			} 
	}
	/*
	    ActionEventHandler
	*/
	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
		    if (object == editField)
				editField_EnterHit(event);
		}
	}
	
	void editField_EnterHit(java.awt.event.ActionEvent event)
	{
	    selectedCell.setText(editField.getText());
	    editCell(selectedCell,false);
	}

    
}
