import java.util.*;

class Tree extends Object {

	public static int ID, nextID=0;
	Vector parents;
	Node   child;
	Vector Links;
	int id;
	CondProb condProb;
	NeuralNetwork NeuralNet;		
		
	public Tree() {
            super();
	    parents = new Vector();
	    Links = new Vector(1);
	    ID=nextID; nextID++;
    }
   
	public int getId(){ return id; }

	public void setCondProb(CondProb c){ condProb = c; }
	public CondProb getCondProb(){ return condProb; }

	public void setChild(Node n){ child = n; }
	public Node getChild(){ return child; }

	public void setParents(Vector ns){ parents = ns; }
	public Vector getParents(){ return parents; }

	public void addParent(Node n){ parents.addElement(n);}

	public Vector getLinks(){  return Links; }
	public void setLinks (Vector links){ Links = links;}
	public void addLink(Link l){   Links.addElement(l); }
	public void removeLink(Link link) {Links.removeElement(link);}
	public int linkSize() { return Links.size(); }
	
	public void removeNode(Node n){
	    child = null;
	    parents.removeElement(n);
	}

	public boolean containNode (Node n){
	        return (parents.contains((Object)n) || child == n);
	}

	public int getInputNodeSize(){
            int ans=0;
            for (int i=0;i<parents.size();i++){
            	ans += Math.abs(((Node)parents.elementAt(i)).getDimension());
            }
            return ans;
	}

	public int getOutputNodeSize(){
	    return Math.abs(child.getDimension());
	}

	public void creatCondProb(int type){
	    if (type == 0)
	        condProb = (CondProb)(new NeuralNetwork(child, getInputNodeSize(),getOutputNodeSize()));
	 //   else if (type == 1)
	 //       condProb = (CondProb)(new Reasonable());
	 //   else 
	 //       condProb = (CondProb)(new CondProbTable());
	}
	public String  getCondProbType()
	{
	    Class condProbClass = condProb.getClass();
	    return condProbClass.getName();
	}

 public void createNeuralNetwork()
 {
    NeuralNet = new NeuralNetwork(child,(child.getTree()).getInputNodeSize(),(child.getTree()).getOutputNodeSize()); 
 }
 public void createNeuralNetwork(int hidden,double eff,double mon,int ite,double th)
 {
    NeuralNet = new  NeuralNetwork(child,(child.getTree()).getInputNodeSize(),(child.getTree()).getOutputNodeSize(),hidden);  
    NeuralNet.setEfficiency(eff);
    NeuralNet.setMomentum(mon);
    NeuralNet.setIteration(ite);
    NeuralNet.setThreshold(th);
 }
 public NeuralNetwork getNeuralNetwork()
 {
    return NeuralNet;
 }
 public void startLearningNeuralNetwork()
 {
    NeuralNet.Learn();
 }
 public void suspendLearningNeuralNetwork()
 {
    NeuralNet.suspendLearn();
 }
 public void restartLeaningNeuralNetwork()
 {
    NeuralNet.restartLearn();
 }
 public void noticeGraphFrameToNeuralNet(GraphCanvas g){
    NeuralNet.setGraph(g);
 }
 public void setTeachPattern()
 {
    NeuralNet.getTeachPattern(new DataSet());  
 }
	
}

